<template>
    <div class="Updates">
        <h2 class="grey--text pl-10">Next Updates</h2>
        <v-container class="my-5">
            <v-row class="pa-2 ml-3 mb-3">
                <v-tooltip top>
                    <template v-slot:activator="{ on, attrs }">
                        <v-btn class="ml-2 mr-2" small color="blue lighten-4" @click="sortBy('title')" v-bind="attrs" v-on="on">
                            <v-icon left small>folder</v-icon>
                            <span class="caption text-lowercase">By update title</span>
                        </v-btn>
                    </template>
                    <span>Sort updates by title</span>
                </v-tooltip>
                <v-tooltip top>
                    <template v-slot:activator="{ on, attrs }">
                        <v-btn class="ml-2 mr-2" small color="blue lighten-4"  @click="sortBy('status')" v-bind="attrs" v-on="on">
                            <v-icon left small>hourglass_empty</v-icon>
                            <span class="caption text-lowercase">By status</span>
                        </v-btn>
                    </template>
                    <span>Sort updates by status</span>
                </v-tooltip>
            </v-row>
            <v-card flat class="pa-2 ma-3" v-for="update in updates" :key="update.title">
                <v-row :class="`update ${update.status}`">
                    <v-col cols="4">
                        <div class="caption grey--text">Title</div>
                        <div>{{update.title}}</div>
                    </v-col>
                    <v-col cols="3">
                        <div class="caption grey--text">Person in charge</div>
                        <div>{{update.person}}</div>
                    </v-col>
                    <v-col cols="3">
                        <div class="caption grey--text">Due by</div>
                        <div>{{update.due}}</div>
                    </v-col>
                    <v-col cols="2">
                        <div class="text-center">
                            <v-chip small :class="`${update.status} white--text caption my-2`">{{update.status}}</v-chip>
                        </div>
                    </v-col>
                </v-row>
            </v-card>
        </v-container>
    </div>
</template>
<script>
import db from '@/fb'
export default {
    data() {
        return {
            updates: []
        }
    },
    methods: {
        sortBy(prop){
            this.updates.sort((a,b) => a[prop] < b[prop] ? -1 : 1)
        }
    },
    created(){
        db.collection('updates').onSnapshot(res => {
            const changes = res.docChanges();
            changes.forEach(change => {
                if ('added' === change.type){
                    this.updates.push({
                        //get the fields AND the ID
                        ...change.doc.data(),
                        id: change.doc.id
                    })
                }
            });
        })
    }
}
</script>

<style>
.update.Complete {
    border-left: 4px solid #3cd1c2; 
}
.update.Ongoing {
    border-left: 4px solid orange; 
}
.update.Overdue {
    border-left: 4px solid red; 
}
.update.Conception {
    border-left: 4px solid grey; 
}

.v-chip.Complete {
    background: #3cd1c2 !important; 
}
.v-chip.Ongoing {
    background: orange !important;  
}
.v-chip.Overdue {
    background: red !important;  
}
.v-chip.Conception {
    background: grey !important;  
}
</style>